var j = jQuery.noConflict();

j(function() {
	/* Force to hide cause I need the functionalities inside this support */
	if( j('#w3b-gallery').length ) {
		j('#postimagediv').remove();
		j('#edit-slug-box').remove();
	}
	
	j('#w3b_gallery').on('click', function(e){
		if (this.window === undefined) {
	        this.window = wp.media({
	                title: 'Insert a media',
	                library: {type: 'image'},
	                multiple: true,
	                button: {text: 'Select'}
	            });

	        var self = this; // Needed to retrieve our variable in the anonymous function below
	        this.window.on('select', function() {
	                var selections = self.window.state().get('selection').toJSON();

	                for(y=0; y<selections.length ;y++) {
	                	var id = selections[y].id;
	                	if (typeof selections[y].sizes.thumbnail != "undefined") {
	                		console.log( selections );
	                		var src = img = selections[y].sizes.thumbnail.url;

	                		if (typeof selections[y].sizes.medium != "undefined")
		                		var img_m = selections[y].sizes.medium.url;
		                	else
		                		var img_m = selections[y].sizes.full.url;
	                		var d = j('#w3b_gallery_d').val();
	                		
	                		if( j('#w3b_gallery_preview:disabled').length ) {
	                			if( d == 'masonry')
	                				src = img_m;

	                			var elem = j('<li></li>')
	                			.attr('data-id', id)
	                			.attr('data-cropped', img)
	                			.attr('data-masonry', img_m)
	                			.html('<a href="#" class="w3b-gallery__icon w3b-gallery__btn-remove"><i class="w3b-ico w3b-ico-close"></i></a> <a href="#" class="w3b-gallery__btn-edit w3b-gallery__icon "><i class="w3b-ico w3b-ico-settings"></i></a> <a href="#" class="w3b-gallery__btn-edit"><img src="'+ src +'"></a>');

	                			j('#w3b-gallery__sortable').isotope()
								.append( elem )
								.isotope( 'appended', elem )
								.isotope('layout');
							}
							else {
								j('#w3b-gallery__sortable').append('<li data-id="'+ id +'" data-cropped="'+ img +'" data-masonry="'+ img_m +'"><a href="#" class="w3b-gallery__icon w3b-gallery__btn-remove"><i class="w3b-ico w3b-ico-close"></i></a> <a href="#" class="w3b-gallery__btn-edit w3b-gallery__icon "><i class="w3b-ico w3b-ico-settings"></i></a> <a href="#" class="w3b-gallery__btn-edit"><img src="'+ src +'"></a></li>');
							}
	                	}
						else
	                		alert('You will need at least 150x150 image size for the gallery to work properly.')
	                }
	            });
	    }

	    this.window.open();
	    return false;
	});
	
	j('.w3b-gallery__wrapper').on('click', '.w3b-gallery__btn-edit', function(e) {
		
		if (this.window === undefined) {
			var that = this;

			this.window = wp.media({
				title		:	"Edit",
				multiple	:	false,
				button		:	{ text : "Update" }
			})
			
			this.window.on('open',function () {
				var selection = that.window.state().get('selection');
				selection.add(wp.media.attachment(j(e.currentTarget).closest('li')[0].getAttribute('data-id')));
				j(that.window.$el).find('.attachments')[0].style.display = "none";
				j(that.window.$el).find('.media-frame-router')[0].style.display = "none";
				j(that.window.$el).find('.media-toolbar')[0].style.display = "none";
				j(that.window.$el).find('.media-sidebar')[0].style.position = "relative";
				j(that.window.$el).find('.media-sidebar')[0].style.width = "96%";
			});
			
			this.window.on('close', function () {
				
			});
			
		}
		this.window.open();
		
		e.preventDefault();
	});

	if( j('#w3b-gallery__sortable').length ) {
		// j('#w3b-gallery__sortable').sortable();
		// j('#w3b-gallery__sortable').disableSelection();

    	j('#post').submit(function(e) {
    		update_gallery();
    	});

    	// masonry
		var imgLoad = imagesLoaded( '#w3b-gallery__sortable' );
		imgLoad.on( 'done', function() {
			var grid = j('#w3b-gallery__sortable').isotope({
			  // options
			  itemSelector: 'li'
			});

			// Toggle
			j('#w3b_gallery_d').on('change', function() {
				if( j('#w3b_gallery_preview:disabled').length ) {
					j('#w3b-gallery__sortable li').each(function (){
						var d = j('#w3b_gallery_d').val();
						var img = j(this).data( d );
						j(this).find('img').attr('src',img);
					});

					grid.imagesLoaded().progress( function() {
						grid.isotope({
							'layoutMode'	: 'masonry'
						});
					});
				}
			});

			// Preview
			j('#w3b_gallery_preview').on('click', function(e) {
				j('#w3b_gallery_sort').attr('disabled', false);
				j(this).attr('disabled', 'disabled');

				j('#w3b-gallery__sortable li').each(function (){
					var d = j('#w3b_gallery_d').val();
					var img = j(this).data( d );
					j(this).find('img').attr('src',img);
				});

				grid.imagesLoaded().progress( function() {
					grid.isotope({
						'layoutMode'	: 'masonry'
					});
					j('#w3b-gallery__sortable').sortable('destroy');
				});
			});

			// Sort
			j('#w3b_gallery_sort').on('click', function(e) {
				j('#w3b_gallery_preview').attr('disabled', false);
				j(this).attr('disabled', 'disabled');

				j('#w3b-gallery__sortable li').each(function (){
					var img = j(this).data('cropped');
					j(this).find('img').attr('src',img);
				});

				grid.imagesLoaded().progress( function() {
					grid.isotope('destroy');
					j('#w3b-gallery__sortable').sortable();
					j('#w3b-gallery__sortable').disableSelection();
				});
			});

			// Remove
			j('.w3b-gallery__wrapper').on('click', '.w3b-gallery__btn-remove', function(e) {
				j(this).parent().remove();
				if( j('#w3b_gallery_preview:disabled').length ) {
					grid.isotope({
						'layoutMode'	: 'masonry'
					});
				}
				e.preventDefault();
			});
		});
	}

	function cleanup( text ) {
		return text.toLowerCase().replace(/[^\w ]+/g,'').replace(/[ ]+/g,'_');
	}

	function redirect( href ) {
		location.href = href;
	}

	function update_gallery() {
		var gallery = [];
		j('#w3b-gallery__sortable li').each(function(e) {
			gallery[gallery.length] = j(this).data('id');
		});
		j('#w3b-gallery__images').val( JSON.stringify( gallery ) );
	}
});